package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmAnnualOutputValueInfo;
import com.zksy.system.basicData.service.CrmAnnualOutputValueInfoService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 年产值Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmAnnualOutputValueInfo")
@Api(tags = "年产值", description = "年产值desc")
public class CrmAnnualOutputValueInfoController extends BaseController {

    @Autowired
    private CrmAnnualOutputValueInfoService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "年产值搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "年产值分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "年产值查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增年产值
     */
    @PostMapping("/save")
    @ApiOperation(value = "年产值新增")
    @Log(title = "新增年产值", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmAnnualOutputValueInfo crmAnnualOutputValueInfo) {
        return service.save(crmAnnualOutputValueInfo);
    }

    /**
     * 修改年产值
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "年产值修改")
    @Log(title = "修改年产值", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmAnnualOutputValueInfo crmAnnualOutputValueInfo) {
        return service.updateById(crmAnnualOutputValueInfo);
    }

    /**
     * 导入年产值
     */
    @ApiOperation("年产值导入")
    @Log(title = "年产值", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmAnnualOutputValueInfo> crmAnnualOutputValueInfoAll = service.list();
            List<CrmAnnualOutputValueInfo> list = ExcelUtils.readMultipartFile(file, CrmAnnualOutputValueInfo.class,CrmAnnualOutputValueInfo.class.getDeclaredFields().length - 2);
            if(crmAnnualOutputValueInfoAll != null && crmAnnualOutputValueInfoAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("年产值导出")
    @Log(title = "年产值", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmAnnualOutputValueInfo> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"年产值",wrapperList,CrmAnnualOutputValueInfo.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "年产值", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除年产值", notes = "删除年产值")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业年产值模板");
    }
}

